/***************************************************************************
 *   Copyright (C) 2003 by Jason Turner                                    *
 *   jason@whensdinner.com                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#if defined(__GNUG__) && !defined(__APPLE__)
	#pragma interface "BookViewCtrl.h"
#endif

#ifndef _BOOKVIEWCTRL_H_

	#define _BOOKVIEWCTRL_H_

	#include <wx/wx.h>
	#include "biblestudy.h"
	#include <wx/notebook.h>
	#include "BookModule.h"

	class BookViewCtrl;

	#include "BookViewEventHandler.h"

	using namespace sword;
	using namespace std;

	BEGIN_DECLARE_EVENT_TYPES()
		DECLARE_EVENT_TYPE(bsEVT_CHILD_SET_FOCUS, 1)
	END_DECLARE_EVENT_TYPES()

	#define EVT_CHILD_SET_FOCUS(id, fn) DECLARE_EVENT_TABLE_ENTRY(bsEVT_CHILD_SET_FOCUS, id, -1, (wxObjectEventFunction)(wxEventFunction)(wxCommandEventFunction)&fn, (wxObject *) NULL ),


	/**
	* Tabbed viewing of book modules
	*
	**/
	class BookViewCtrl : public wxNotebook
	{
	private:
		BookViewEventHandler *m_CustEventHandler;

	public:
		BookViewCtrl(wxWindow *parent, int id, const wxPoint pos, const wxSize size);
		~BookViewCtrl();

		int AddTab();
		void CloseTab();
		void CloseOtherTabs();
		void DuplicateTab();
		void DuplicateTab(BookModule *);

		/**
		 * Sets the module for the active tab
		 */
		void OpenInCurrentTab(SWModule *);
		void OpenInCurrentTab(BookModule *);
		void OpenInCurrentTab(wxString html);

		void OpenInNewTab(SWModule *);
		void OpenInNewTab(BookModule *);
		void OpenInNewTab(wxString html);

		void AddToCurrentTab(SWModule *);
		void AddToCurrentTab(BookModule *);

		void LookupKey(wxString key);
		void BrowseKey(wxString key);
		void Search(wxString range, wxString search, int searchtype);
		void BrowseForward();
		void BrowseBackward();

		void ChildGotFocus();
		void PostChildSetFocus(BookModule *bm=NULL);
		void OnSetFocus(wxFocusEvent &event);
		void OnLeftUp(wxMouseEvent &event);
		void OnNotebookPageChanged(wxNotebookEvent &event);

		void SetIcon();

		BookModule *GetActiveBookModule();

		DECLARE_EVENT_TABLE()
	};

#endif
